import { types, File, NodePath, Visitor, Scope, PluginObject, PluginAPI } from '@babel/core';

type DecoratorVersionKind = "2023-11" | "2023-05" | "2023-01" | "2022-03" | "2021-12";

declare function buildCheckInRHS(rhs: types.Expression, file: File, inRHSIsObject?: boolean): types.Expression;

interface RenamerState {
    scope: Scope;
}
declare function injectInitialization(path: NodePath<types.Class>, constructor: NodePath<types.ClassMethod> | undefined, nodes: types.ExpressionStatement[], renamer?: (visitor: Visitor<RenamerState>, state: RenamerState) => void, lastReturnsThis?: boolean): void;

declare const FEATURES: Readonly<{
    fields: number;
    privateMethods: number;
    decorators: number;
    privateIn: number;
    staticBlocks: number;
}>;
declare function enableFeature(file: File, feature: number, loose: boolean): void;

interface Options {
    name: string;
    feature: number;
    loose?: boolean;
    inherits?: PluginObject["inherits"];
    manipulateOptions?: PluginObject["manipulateOptions"];
    api?: PluginAPI;
    decoratorVersion?: DecoratorVersionKind | "2018-09";
}
declare function createClassFeaturePlugin({ name, feature, loose, manipulateOptions, api, inherits, decoratorVersion, }: Options): PluginObject;

export { FEATURES, buildCheckInRHS, createClassFeaturePlugin, enableFeature, injectInitialization };
